/* 
A “dormitory” object can be defined so that a Java thread can “toSleep” in it 
up to a wake-up event. Design and implement a DormitorySemSem class with a given 
number of sleeping seats to be specified at construction time; provide it with 
the following methods:
toSleep(), to be called to sleep in one of the available seats; in case no seat 
is available, it will block so to access the dormitory in future sleeping turns;
trySleep(), to be called to sleep in the current sleeping turn; in case no seat 
is available, it doesn’t block, returning a ‘false’ value, otherwise it 
succeeds and returns a ‘true’ value;
wakeUpAll() to wake up the current occupants and free their seats; in practice, 
a single sleeping turn is delimited by two successive invocations of 
wakeUpAll().

Design and implement the “DormitorySemSem” class so that no thread may starve in 
invoking “toSleep”. Sketch also a test program to show how this synchronization 
mechanism can be actually used.
*/

package mySynchMeans;


public class CDS_05_SynchronizerSetting {
    
    public static final int NUMWORKERS = 4;
    public static final int NBEDS = 3;

    public static void main(String[] args) {
        
        DormitorySemSem myDorm = new DormitorySemSem(NBEDS, true); //verbose activated
        System.out.println("Initially Av. Permits: "+myDorm.accessGate.availablePermits()+"\n");
        
        Thread[] wks = new TiredWorker[NUMWORKERS];
        String[] names = {"Ciro   ","Mario  ","Antonio","Ugo    ","Paolo  ","Lapo   "};
        
        Thread   br = new BellRinger("Massimiliano***", myDorm);
        
        for(int i=0; i<NUMWORKERS; i++) {
            wks[i]=new TiredWorker(names[i%names.length]+" - T"+Integer.toString(i), myDorm);
        }
        
        for(int i=0; i<NUMWORKERS; i++) {
            wks[i].start();
        }
        
        br.start();         
    }
}
