
package mySynchMeans;

//import java.util.concurrent.TimeUnit;


public class TiredWorker extends Thread {
    
    private static final int MINTIME = 500;
    private static final int MAXTIME = 1500;
    private final java.util.Random myRNG = new java.util.Random();
    
    private final Dormitory myDormitory;
    
    
    public TiredWorker(String name, Dormitory d) {
        myDormitory = d;
        this.setName(name);
    }
    
    @Override
    public void run() {
        
        while(true) {
            try {
                //working time
                int workingPeriod  = MINTIME + myRNG.nextInt(MAXTIME-MINTIME);
                Thread.sleep(workingPeriod);
                
                if (workingPeriod %3 !=0) {
                    myDormitory.toSleep();
                }
                else {
                    myDormitory.tryToSleep();
                }
                
            }
            catch(InterruptedException ie) {
                System.out.println(ie.getMessage());
            }
        }
    }
}
