package mySynchMeans;

import org.junit.AfterClass;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author alessio
 */
public class FaultyAdderTest {
    final static int MAXBOUND= 10000;
    final static int MINBOUND=-10000;
    final static double DELTA=1E-12;
    
    public FaultyAdderTest() {
    }
    
    @BeforeClass
    public static void setUpClass() {
    }
    
    @AfterClass
    public static void tearDownClass() {
    }

    /**
     * Test of add method, of class FaultyAdder.
     * This (dumb) test is aimed at verifying that
     * adding 0 to a given number leaves it unchanged.
     */
    @Test
    public void testAdd() {
        
        double x = new java.util.Random().nextDouble()*(MAXBOUND-MINBOUND)+MINBOUND;
        FaultyAdder instance = new FaultyAdder();
        double result = instance.add(x, 0);
        
        String msg= "Test #1 for add: "+x+" + 0 = "+result;
        
        assertEquals(msg, x, result, DELTA);
    }

     /**
     * Test of add method, of class FaultyAdder.
     * This (dumb) test is aimed at verifying that
     * adding the opposite to a given number always yields zero. 
     */
    @Test
    public void testAdd2() {
        double x = new java.util.Random().nextDouble()*(MAXBOUND-MINBOUND)+MINBOUND;
        double y = -x;
        FaultyAdder instance = new FaultyAdder();
        int expResult = 0;
        double result = instance.add(x, y);
        String msg = "Test #2 for add: "+x+" + "+y+" = "+result;
        
        assertEquals(msg, expResult, result, DELTA);
        
    }
    
}
